
#!/bin/sh
# -*- perl -*-
exec perl -x $0 ${1+"$@"}
#!perl


#my @mylist=qw/one two three four/;
#my @comb=combinations(@mylist);
#foreach(@comb){
#  print join(' ',@$_),"\n";
#}


sub combinations{
  my @result=([]);
  my @list=@_;

  foreach my $item (@list){
    @result=map {[@$_],[@$_,$item]} @result;
  }
  shift @result; #get rid of the empty entry
  return @result;
}


if (@ARGV < 1) 
{
    &print_usage;
    exit 1;
}
$data_file = $ARGV[0];

    
open(Data, $data_file) || die "Can't open $data_file\n";
@data = <Data>; 
close(Data);
$exp_num = @data;
#print(@sort_data);

chomp($data[0]);
@signs = split(",", $data[0]);
$param_num = $#signs;

# generate all combinations
@mylist=1..$param_num;
my @comb=combinations(@mylist);
#print map { "@$_\n" } @comb;

for (my $i = 0; $i < $exp_num; ++$i) {
    $totals[$i] = 0;
}

for (my $i = 0; $i < $exp_num; ++$i)	
{
    chomp($data[$i]);
    my @signs = split(",", $data[$i]);
    for (my $j = 0; $j < @comb; ++$j)
    {
	my $sign = 1;
	foreach my $p (@{@comb[$j]}) {
	    $sign *= $signs[$p-1];
	}

	$totals[$j] += $sign*$signs[$param_num];
    }
    $totals[$exp_num] +=$signs[$param_num];
}

#print "here @totals\n";
$total_var = 0;
for (my $i = 0; $i < @comb; ++$i)	
{
    $final_result[$i] = join " ", @{@comb[$i]};
    $final_result[$i] = $final_result[$i]. ",".$totals[$i]/$exp_num; 
    $total_var +=  $totals[$i]*$totals[$i];
}

$final_result[@final_result]="none".",".$totals[$exp_num]/$exp_num;
$total_var /= ($exp_num * $exp_num);
@sort_result = sort(result_sort @final_result);
@parameters = `sed -n '/^\\[parameters\\]/,/^\\[\\/parameters\\]/p' ex_ff.conf\n`;
print "The parameter index represents:\n";
$index = 1;
for (my $i = 1; $i < $#parameters; $i++) {
    if  ($parameters[$i]!~/^#/) {
	 my @fields = split " ", $parameters[$i];
	 if (@fields > 2) {
	     print "$index\t$fields[0]\n";
	     $index++;
	 }
    }
}
print "\nParameter(s)\t\tEffect\t\tVariation Percentage\n";
print "-------------------------------------------------------------\n";
for (my $i = 0; $i < @sort_result; ++$i)	
{
    my @tmp = split(",", $sort_result[$i]);
    if ($tmp[0] == "none") {
	printf("%s\t\t\t%f\n", $tmp[0],$tmp[1]);
    } else {
	printf("%s\t\t\t%f\t\t%4.2f\%\n", $tmp[0],$tmp[1],100*$tmp[1]*$tmp[1]/$total_var);
    }
}
print "-------------------------------------------------------------\n";
#print map {"$_\n"} @sort_result;
#print "@sort_result";

sub result_sort {
    local(@tmp);
    local($a) = $a;
    local($b) = $b;
    @tmp = split(",", $a);
    $a_result = $tmp[$#tmp];
    @tmp = split(",",$b);
    $b_result = $tmp[$#tmp];
    (-abs($a_result) <=> -abs($b_result));
}



sub print_usage {
    print "Usage: get-effect <data_file>\n"
}
