# tcp.tcl -- skeleton file for assg#5

#SETPARAMETERS  
#tcp_version	0	1
#buffer_size	50	500
#ack_type	0	1
#segment_size	100	1000
#aqm		0	1


# You need to write code to set tcp source ($tcp_src_type) and sink ($tcp_sink_type) according to the relevant parameter ($tcp_version) 
# Begin here --------------------------------------
if { } { ;# TCP Reno
   set
   set 
} else { ;# TCP SACK
   set
   set 
}
# End here ----------------------------------------



# To use RPI Graphing Tool
source $env(NS)/tcl/rpi/graph.tcl
source $env(NS)/tcl/rpi/link-stats.tcl
source $env(NS)/tcl/rpi/script-tools.tcl
source /home/net/lab5/ns-measurement.tcl

Graph set plot_device_class_ xgraph
Agent/TCP set window_ 1000000   ;# sooo high so it will never hit it!

#Global parameters
set no_of_flows 10
set run_time 5

#create scheduler
set ns [new Simulator]
#use-nam ;# to save time, don't use nam

#choose colors
$ns color 0 blue
$ns color 1 red
$ns color 2 green

#turn tracing on
set ns_f [open tcpudp.tr w]
$ns trace-all $ns_f
set nam_f [open tcpudp.nam w]
$ns namtrace-all $nam_f

#create topology
set n0 [$ns node]
set n1 [$ns node]
set n2 [$ns node]
set n3 [$ns node]

$ns duplex-link $n0 $n2 1Mb 1ms DropTail
$ns duplex-link $n1 $n2 1Mb 1ms DropTail

# Here is a sample code to set AQM on link n2--n3
if {$aqm == 0} {
    $ns duplex-link $n2 $n3 600Kb 30ms DropTail
} else {
    $ns duplex-link $n2 $n3 600Kb 30ms RED
    Queue/RED set thresh_ [expr $buffer_size/3]
    Queue/RED set maxthresh_ [expr $buffer_size*2/3]
}


# Then limit queue size of # of packets
$ns queue-limit $n2 $n3 $buffer_size

#adjust nam orientation
$ns duplex-link-op $n0 $n2 orient right-down
$ns duplex-link-op $n1 $n2 orient right-up
$ns duplex-link-op $n2 $n3 orient right

#turn nam visualization for n2-n3 queue 
#it just defines an angle of how to display queue
$ns duplex-link-op $n2 $n3 queuePos 0.5


#create and attach TCP agents to source/sink
for {set i 0} {$i < $no_of_flows} {incr i} {
    set tcp($i) [new $tcp_src_type]
    $tcp($i) set class_ 2
    $tcp($i) set packetSize $segment_size
    set sink($i) [new $tcp_sink_type]
    $ns attach-agent $n1 $tcp($i)
    $ns attach-agent $n3 $sink($i)
    $ns connect $tcp($i) $sink($i)

    #attach an ftp application to the TCP agent
    set ftp($i) [new Application/FTP]
    $ftp($i) attach-agent $tcp($i)
    set app($i) [$sink($i) attach-app TraceReceiver]
    $ns at 0 "$app($i) start"
 
    #schedule ftp application
    $ns at [expr 0.1+ $i/100] "$ftp($i) start"
    $ns at $run_time "$ftp($i) stop"
}

set util_graph [new Graph/UtilizationVersusTime $n2 $n3 0.1]
$util_graph set title_ "Bottleneck Utilization vs Time"

set qlen_graph [new Graph/QLenVersusTime $n2 $n3]
$qlen_graph set title_ "Bottleneck Queue Length vs Time"

set stats [new LinkStats $n2 $n3]

proc finish {} {
  global util_graph qlen_graph stats no_of_flows app run_time

    #  $util_graph display
    #  $qlen_graph display

    # link statistics

    # if you need bottleneck utilization, uncomment this
# Begin here --------------------------------------
    #  return_result [$stats get-utilization]
# End here ----------------------------------------


    # if you need average queuing delay, uncomment this
# Begin here --------------------------------------
    #  return_result [$stats get-mean-queue-delay]
# End here ----------------------------------------


    # if you need total goodput, uncomment this
# Begin here --------------------------------------
    set total_bytes 0
    for {set i 0} {$i < $no_of_flows} {incr i} {
        set total_bytes [expr $total_bytes + [$app($i) set bytes_]]
    }
    return_result [expr $total_bytes / ($run_time - 0.1)]
# End here ----------------------------------------

    exit 0
}

$ns at 6.0 "finish"

$ns run


